import numpy as np
# you may import other functions/files from mytorch

class RNN:

    def __init__(self, num_inputs, num_hiddens):
        """
        Initialize the weights to be zero-mean Gaussian with 
        variance 0.01. Ignore the bias term.

        :param num_inputs: Dimension of inputs.
        :param num_hiddens: Dimension of hidden state.
        """

    def forward(self, inputs, state=None):
        """
        Forward operation of RNN layer. Performs
        operation H_t+1 = tanh(Xt*Wxh + Ht*Whh).

        :param inputs: Input data matrix with shape (num_steps, batch_size, num_inputs).
        :param state: Initial hidden state with shape (batch_size, num_hiddens).
        :return outputs: Output data matrix after linear transformation.
        :return state: Final hidden state for each element in the batch.
        """
        if state is None:
            state = np.zeros((inputs.shape[1], self.num_hiddens))
            
        return None
        
    def backward(self, dLdO):
        """
        Backpropagation operation for variables in RNN
        layer. Stores derivatives dLdWxh, dLdWhh.

        :param dLdO: Derivative of loss with respect to output.
        Obtained from backward operation on loss object.
        :returns None:
        """
        
        return None